/*
    Rafet SAPANCI  rafetsapanci@hotmail.com                          20.07.2006
        
                      MMCDOS.C UYGULAMA DENEMES
    
    
Ksa aklama:

-mmc ye data yazmada bir seferde 512byte yazlmaktadr. Deneme amal olarak
oku[32] eklinde bir deikene yazlan karakterler mmc ye yalmkaktadr.
Buradaki deiken 32 byte olmasna ramen yazma ilemi yine 512byte olarak
gereklemektedir. Tanmlanmayan blgelere SIFIR bilgisi yazlmaktadr.

Uygulamada "yazilan DENEME" bilgisi mmc nin  0 nolu adresinden itibaren yalmtr.
     
    
-okuma uygulamasnda Data[512] dizisine mmc nin 0x0000 adresinden 512 byte
okunarak seri porta hem HEX hemde CHAR olarak yazdrlmaktadr.

Okuma ileminde tanmladmz dizin boyutu kadar deer okunmaktadr. 
Yazma ilaminde yazacamz bilgi 512 byte den kk olsa bile bir seferde 512bytelik 
yazma ilemi gerekletirilmektedir.

Ekteki dosyalarda Proteus 6.9 SP4 ile yaplm simlasyon dosyas bulunmaktadr.

*/

#include "r mmc 452.h"

#define MMC_CLK   PIN_C3
#define MMC_DI    PIN_C4
#define MMC_DO    PIN_C5
#define MMC_CS    PIN_C2



#DEFINE _CS PIN_C2

#DEFINE MAX_FILES 2 /// max number of open files
#DEFINE MMC_BUFF_SIZE 32 /// 32 for PCM


//#include <mmc_spi_rft.c>
#include<mmcdos.c>


void main()
{
int mok;
char deneme,okunan;
char oku[32]={'y','a','z','i','l','a','n',' ','D','E','N','E','M','E'};
char dz1[32];
char data[512];
int16 i,j,k,l;

   setup_adc_ports(NO_ANALOGS);
   setup_adc(ADC_OFF);
   setup_psp(PSP_DISABLED);
   //setup_spi(SPI_MASTER|SPI_H_TO_L|SPI_CLK_DIV_64);
   SETUP_SPI(SPI_MASTER | SPI_CLK_DIV_16 | SPI_H_TO_L |SPI_XMIT_L_TO_H ); //msdos
   //setup_spi(SPI_MASTER | SPI_XMIT_L_TO_H | SPI_L_TO_H | SPI_CLK_DIV_64 ); mmc spi rft
   setup_wdt(WDT_OFF);
   setup_timer_0(RTCC_INTERNAL);
   setup_timer_1(T1_DISABLED);
   setup_timer_2(T2_DISABLED,0,1);
   setup_timer_3(T3_DISABLED|T3_DIV_BY_1);
   setup_oscillator(True);



   set_tris_c(0b10010011);         //c7=rx IN, c6=tx OUT, c5 SDO OUT ,c4 SDI IN

   output_high(MMC_CS);

   printf("Hadi hayirlisi UMARIM CALISIR  \r\r");

   mok=init_mmc(10);

   printf("Gelen Cevap: %u\r\r",mok);

   SET_BLOCKLEN( 512);

//------------------
      MMC_dir_protected=false; // data yazma modunu a
      write_BLOCK( 0, oku, 512);
//------------------
printf ("HEX olarak okunan datalar                          CHAR olarak okunan datalar\r");
read_BLOCK(0,data);

      j=0;
      l=0;
      for(i=0;i<512;i++)
      {
         printf("%2X ",data[i]);
         j++;
         l++;
         if (j== 16)
         {
           printf("   ");

           for (k=l-16;k<l;k++)
           printf("%2C ",data[k]);
           
          putc('\r');
          j=0;
         }
      }


putc('\r');


  if (get_CID(dz1))
   {
         printf("\rMMC CID: "); 
         for(i=0;i<10;i++)
         printf("%C ",dz1[i]);
   }

   putc('\r');

   if (get_CSD(dz1))
   {
      printf("\rMMC CSD: "); 
      for(i=0;i<16;i++)
         printf("%X ",dz1[i]);
   }



   while(true)
   {

   }
}
